<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/memchr-2.5.0/src/memmem/util.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>util.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../memchr/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../memchr/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../memchr/index.html"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
</pre><pre class="rust"><code><span class="comment">// These routines are meant to be optimized specifically for low latency as</span>
<span class="comment">// compared to the equivalent routines offered by std. (Which may invoke the</span>
<span class="comment">// dynamic linker and call out to libc, which introduces a bit more latency</span>
<span class="comment">// than we&#39;d like.)</span>

<span class="doccomment">/// Returns true if and only if needle is a prefix of haystack.</span>
<span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">is_prefix</span>(<span class="ident">haystack</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>], <span class="ident">needle</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="ident">bool</span> {
    <span class="ident">needle</span>.<span class="ident">len</span>() <span class="op">&lt;</span><span class="op">=</span> <span class="ident">haystack</span>.<span class="ident">len</span>() <span class="op">&amp;&amp;</span> <span class="ident">memcmp</span>(<span class="kw-2">&amp;</span><span class="ident">haystack</span>[..<span class="ident">needle</span>.<span class="ident">len</span>()], <span class="ident">needle</span>)
}

<span class="doccomment">/// Returns true if and only if needle is a suffix of haystack.</span>
<span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">is_suffix</span>(<span class="ident">haystack</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>], <span class="ident">needle</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="ident">bool</span> {
    <span class="ident">needle</span>.<span class="ident">len</span>() <span class="op">&lt;</span><span class="op">=</span> <span class="ident">haystack</span>.<span class="ident">len</span>()
        <span class="op">&amp;&amp;</span> <span class="ident">memcmp</span>(<span class="kw-2">&amp;</span><span class="ident">haystack</span>[<span class="ident">haystack</span>.<span class="ident">len</span>() <span class="op">-</span> <span class="ident">needle</span>.<span class="ident">len</span>()..], <span class="ident">needle</span>)
}

<span class="doccomment">/// Return true if and only if x.len() == y.len() &amp;&amp; x[i] == y[i] for all</span>
<span class="doccomment">/// 0 &lt;= i &lt; x.len().</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Why not just use actual memcmp for this? Well, memcmp requires calling out</span>
<span class="doccomment">/// to libc, and this routine is called in fairly hot code paths. Other than</span>
<span class="doccomment">/// just calling out to libc, it also seems to result in worse codegen. By</span>
<span class="doccomment">/// rolling our own memcmp in pure Rust, it seems to appear more friendly to</span>
<span class="doccomment">/// the optimizer.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// We mark this as inline always, although, some callers may not want it</span>
<span class="doccomment">/// inlined for better codegen (like Rabin-Karp). In that case, callers are</span>
<span class="doccomment">/// advised to create a non-inlineable wrapper routine that calls memcmp.</span>
<span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">memcmp</span>(<span class="ident">x</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>], <span class="ident">y</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="ident">bool</span> {
    <span class="kw">if</span> <span class="ident">x</span>.<span class="ident">len</span>() <span class="op">!</span><span class="op">=</span> <span class="ident">y</span>.<span class="ident">len</span>() {
        <span class="kw">return</span> <span class="bool-val">false</span>;
    }
    <span class="comment">// If we don&#39;t have enough bytes to do 4-byte at a time loads, then</span>
    <span class="comment">// fall back to the naive slow version.</span>
    <span class="comment">//</span>
    <span class="comment">// TODO: We could do a copy_nonoverlapping combined with a mask instead</span>
    <span class="comment">// of a loop. Benchmark it.</span>
    <span class="kw">if</span> <span class="ident">x</span>.<span class="ident">len</span>() <span class="op">&lt;</span> <span class="number">4</span> {
        <span class="kw">for</span> (<span class="kw-2">&amp;</span><span class="ident">b1</span>, <span class="kw-2">&amp;</span><span class="ident">b2</span>) <span class="kw">in</span> <span class="ident">x</span>.<span class="ident">iter</span>().<span class="ident">zip</span>(<span class="ident">y</span>) {
            <span class="kw">if</span> <span class="ident">b1</span> <span class="op">!</span><span class="op">=</span> <span class="ident">b2</span> {
                <span class="kw">return</span> <span class="bool-val">false</span>;
            }
        }
        <span class="kw">return</span> <span class="bool-val">true</span>;
    }
    <span class="comment">// When we have 4 or more bytes to compare, then proceed in chunks of 4 at</span>
    <span class="comment">// a time using unaligned loads.</span>
    <span class="comment">//</span>
    <span class="comment">// Also, why do 4 byte loads instead of, say, 8 byte loads? The reason is</span>
    <span class="comment">// that this particular version of memcmp is likely to be called with tiny</span>
    <span class="comment">// needles. That means that if we do 8 byte loads, then a higher proportion</span>
    <span class="comment">// of memcmp calls will use the slower variant above. With that said, this</span>
    <span class="comment">// is a hypothesis and is only loosely supported by benchmarks. There&#39;s</span>
    <span class="comment">// likely some improvement that could be made here. The main thing here</span>
    <span class="comment">// though is to optimize for latency, not throughput.</span>

    <span class="comment">// SAFETY: Via the conditional above, we know that both `px` and `py`</span>
    <span class="comment">// have the same length, so `px &lt; pxend` implies that `py &lt; pyend`.</span>
    <span class="comment">// Thus, derefencing both `px` and `py` in the loop below is safe.</span>
    <span class="comment">//</span>
    <span class="comment">// Moreover, we set `pxend` and `pyend` to be 4 bytes before the actual</span>
    <span class="comment">// end of of `px` and `py`. Thus, the final dereference outside of the</span>
    <span class="comment">// loop is guaranteed to be valid. (The final comparison will overlap with</span>
    <span class="comment">// the last comparison done in the loop for lengths that aren&#39;t multiples</span>
    <span class="comment">// of four.)</span>
    <span class="comment">//</span>
    <span class="comment">// Finally, we needn&#39;t worry about alignment here, since we do unaligned</span>
    <span class="comment">// loads.</span>
    <span class="kw">unsafe</span> {
        <span class="kw">let</span> (<span class="kw-2">mut</span> <span class="ident">px</span>, <span class="kw-2">mut</span> <span class="ident">py</span>) <span class="op">=</span> (<span class="ident">x</span>.<span class="ident">as_ptr</span>(), <span class="ident">y</span>.<span class="ident">as_ptr</span>());
        <span class="kw">let</span> (<span class="ident">pxend</span>, <span class="ident">pyend</span>) <span class="op">=</span> (<span class="ident">px</span>.<span class="ident">add</span>(<span class="ident">x</span>.<span class="ident">len</span>() <span class="op">-</span> <span class="number">4</span>), <span class="ident">py</span>.<span class="ident">add</span>(<span class="ident">y</span>.<span class="ident">len</span>() <span class="op">-</span> <span class="number">4</span>));
        <span class="kw">while</span> <span class="ident">px</span> <span class="op">&lt;</span> <span class="ident">pxend</span> {
            <span class="kw">let</span> <span class="ident">vx</span> <span class="op">=</span> (<span class="ident">px</span> <span class="kw">as</span> <span class="kw-2">*const</span> <span class="ident">u32</span>).<span class="ident">read_unaligned</span>();
            <span class="kw">let</span> <span class="ident">vy</span> <span class="op">=</span> (<span class="ident">py</span> <span class="kw">as</span> <span class="kw-2">*const</span> <span class="ident">u32</span>).<span class="ident">read_unaligned</span>();
            <span class="kw">if</span> <span class="ident">vx</span> <span class="op">!</span><span class="op">=</span> <span class="ident">vy</span> {
                <span class="kw">return</span> <span class="bool-val">false</span>;
            }
            <span class="ident">px</span> <span class="op">=</span> <span class="ident">px</span>.<span class="ident">add</span>(<span class="number">4</span>);
            <span class="ident">py</span> <span class="op">=</span> <span class="ident">py</span>.<span class="ident">add</span>(<span class="number">4</span>);
        }
        <span class="kw">let</span> <span class="ident">vx</span> <span class="op">=</span> (<span class="ident">pxend</span> <span class="kw">as</span> <span class="kw-2">*const</span> <span class="ident">u32</span>).<span class="ident">read_unaligned</span>();
        <span class="kw">let</span> <span class="ident">vy</span> <span class="op">=</span> (<span class="ident">pyend</span> <span class="kw">as</span> <span class="kw-2">*const</span> <span class="ident">u32</span>).<span class="ident">read_unaligned</span>();
        <span class="ident">vx</span> <span class="op">==</span> <span class="ident">vy</span>
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="memchr" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>